package com.fs.starfarer.api.impl.campaign.rulecmd;

import java.util.Map;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.characters.PersonAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.TextPanelAPI;
import com.fs.starfarer.api.campaign.econ.CommoditySpecAPI;
import java.awt.Color;
import com.fs.starfarer.api.util.Misc;
import com.fs.starfarer.api.ui.TooltipMakerAPI;
import java.util.Iterator;
import com.fs.starfarer.api.impl.campaign.intel.events.EventFactor;
import kaysaar.aotd_question_of_loyalty.data.intel.eventfactors.onetime.AiCoreSellFactor;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import com.fs.starfarer.api.campaign.comm.CommMessageAPI;
import com.fs.starfarer.api.impl.campaign.CoreReputationPlugin;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.CargoPickerListener;
import com.fs.starfarer.api.campaign.CargoStackAPI;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.impl.campaign.rulecmd.salvage.AICores;

public class AoTDAiCores extends AICores
{
    protected void selectCores() {
        final CargoAPI copy = Global.getFactory().createCargo(false);
        for (final CargoStackAPI stack : this.playerCargo.getStacksCopy()) {
            final CommoditySpecAPI spec = stack.getResourceIfResource();
            if (spec != null && spec.getDemandClass().equals("AI核心")) {
                copy.addFromStack(stack);
            }
        }
        copy.sort();
        final float width = 310.0f;
        this.dialog.showCargoPickerDialog("选择要上交的AI核心", "确认", "取消", true, 310.0f, copy, (CargoPickerListener)new CargoPickerListener() {
            public void pickedCargo(final CargoAPI cargo) {
                if (cargo.isEmpty()) {
                    this.cancelledCargoSelection();
                    return;
                }
                cargo.sort();
                for (CargoStackAPI stack : cargo.getStacksCopy()) {
                    AoTDAiCores.this.playerCargo.removeItems(stack.getType(), stack.getData(), stack.getSize());
                    if (stack.isCommodityStack()) {
                        final int num = (int)stack.getSize();
                        AddRemoveCommodity.addCommodityLossText(stack.getCommodityId(), num, AoTDAiCores.this.text);
                        final String key = "$turnedIn_" + stack.getCommodityId();
                        final int turnedIn = AoTDAiCores.this.faction.getMemoryWithoutUpdate().getInt(key);
                        AoTDAiCores.this.faction.getMemoryWithoutUpdate().set(key, (Object)(turnedIn + num));
                        final String key2 = "$turnedIn_allCores";
                        final int turnedIn2 = AoTDAiCores.this.faction.getMemoryWithoutUpdate().getInt(key2);
                        AoTDAiCores.this.faction.getMemoryWithoutUpdate().set(key2, (Object)(turnedIn2 + num));
                    }
                }
                final float bounty = AoTDAiCores.access$600(AoTDAiCores.this, cargo);
                final float repChange = AoTDAiCores.access$700(AoTDAiCores.this, cargo);
                if (bounty > 0.0f) {
                    AoTDAiCores.this.playerCargo.getCredits().add(bounty);
                    AddRemoveCommodity.addCreditsGainText((int)bounty, AoTDAiCores.this.text);
                }
                if (repChange >= 1.0f) {
                    final CoreReputationPlugin.CustomRepImpact impact = new CoreReputationPlugin.CustomRepImpact();
                    impact.delta = repChange * 0.01f;
                    Global.getSector().adjustPlayerReputation((Object)new CoreReputationPlugin.RepActionEnvelope(CoreReputationPlugin.RepActions.CUSTOM, (Object)impact, (CommMessageAPI)null, AoTDAiCores.this.text, true), AoTDAiCores.this.faction.getId());
                    final CoreReputationPlugin.CustomRepImpact customRepImpact = impact;
                    customRepImpact.delta *= 0.25f;
                    if (impact.delta >= 0.01f) {
                        Global.getSector().adjustPlayerReputation((Object)new CoreReputationPlugin.RepActionEnvelope(CoreReputationPlugin.RepActions.CUSTOM, (Object)impact, (CommMessageAPI)null, AoTDAiCores.this.text, true), AoTDAiCores.this.person);
                    }
                }
                if (QoLMisc.isCommissionedBy(AoTDAiCores.this.faction.getId())) {
                    final int amount = AoTDAiCores.this.calculateCommissionPoints(cargo);
                    AoTDCommIntelPlugin.get().addFactor((EventFactor)new AiCoreSellFactor(amount), AoTDAiCores.this.dialog);
                }
                FireBest.fire((String)null, AoTDAiCores.this.dialog, AoTDAiCores.this.memoryMap, "AICoresTurnedIn");
            }
            
            public void cancelledCargoSelection() {
            }
            
            public void recreateTextPanel(final TooltipMakerAPI panel, final CargoAPI cargo, final CargoStackAPI pickedUp, final boolean pickedUpFromSource, final CargoAPI combined) {
                final float bounty = AoTDAiCores.access$1800(AoTDAiCores.this, combined);
                final float repChange = AoTDAiCores.access$1900(AoTDAiCores.this, combined);
                final float pad = 3.0f;
                final float small = 5.0f;
                final float opad = 10.0f;
                panel.setParaFontOrbitron();
                panel.addPara(Misc.ucFirst(AoTDAiCores.this.faction.getDisplayName()), AoTDAiCores.this.faction.getBaseUIColor(), 1.0f);
                panel.setParaFontDefault();
                panel.addImage(AoTDAiCores.this.faction.getLogo(), 310.0f, 3.0f);
                panel.addPara("Compared to dealing with other factions, turning AI cores in to " + AoTDAiCores.this.faction.getDisplayNameLongWithArticle() + " will result in:", opad);
                panel.beginGridFlipped(310.0f, 1, 40.0f, 10.0f);
                panel.addToGrid(0, 0, "Bounty value", "" + (int)(AoTDAiCores.this.valueMult * 100.0f));
                panel.addToGrid(0, 1, "Reputation gain", "" + (int)(AoTDAiCores.this.repMult * 100.0f));
                panel.addGrid(pad);
                panel.addPara("If you turn in the selected AI cores, you will receive a %s bounty and your standing with " + AoTDAiCores.this.faction.getDisplayNameWithArticle() + " will improve by %s points.", opad * 1.0f, Misc.getHighlightColor(), new String[] { Misc.getWithDGS(bounty), "" + (int)repChange });
                if (AoTDAiCores.this.faction != null && QoLMisc.isCommissionedBy(AoTDAiCores.this.faction.getId())) {
                    panel.addPara("这将使你的晋升点数提升 %s", 10.0f, Color.ORANGE, new String[] { "" + AoTDAiCores.this.calculateCommissionPoints(combined) });
                }
            }
        });
    }
    
    public int calculateCommissionPoints(final CargoAPI cargo) {
        int bounty = 0;
        for (final CargoStackAPI stack : cargo.getStacksCopy()) {
            final CommoditySpecAPI spec = stack.getResourceIfResource();
            if (spec != null && spec.getDemandClass().equals("AI核心")) {
                bounty += (int)(this.getValueOfCore(spec.getId()) * stack.getSize());
            }
        }
        return bounty;
    }
    
    public int getValueOfCore(final String id) {
        if (id.equals("Gamma核心")) {
            return 9;
        }
        if (id.equals("Beta核心")) {
            return 18;
        }
        if (id.equals("Alpha核心")) {
            return 36;
        }
        if (id.equals("Omega核心")) {
            return 42;
        }
        return 40;
    }
    
    static /* synthetic */ float access$600(final AoTDAiCores x0, final CargoAPI x1) {
        return x0.computeCoreCreditValue(x1);
    }
    
    static /* synthetic */ float access$700(final AoTDAiCores x0, final CargoAPI x1) {
        return x0.computeCoreReputationValue(x1);
    }
    
    static /* synthetic */ float access$1800(final AoTDAiCores x0, final CargoAPI x1) {
        return x0.computeCoreCreditValue(x1);
    }
    
    static /* synthetic */ float access$1900(final AoTDAiCores x0, final CargoAPI x1) {
        return x0.computeCoreReputationValue(x1);
    }
}
